
#include <iostream>
#include <cstdlib>
#include <image.hpp>

using namespace cpe;

int main(int argc,char *argv[])
{
    std::cout<<"****"<<std::endl;
    std::cout<<"run "<<argv[0]<<" with "<<argc-1<<" parameters ... \n"<<std::endl;




    try
    {

        image im;

        //load picture
        std::cout<<"=============== LOAD PICTURE ================"<<std::endl;
        std::string filename("data/imtest_1.ppm");
        std::cout<<"Load pic "+filename+" ..."<<std::endl;
        im.read_ppm(filename);
        std::cout<<"Load pic "+filename+" [OK]"<<std::endl<<std::endl;



        //get info
        std::cout<<"=============== GET INFO ================"<<std::endl;
        unsigned int size_x=im.Nx();
        unsigned int size_y=im.Ny();
        std::cout<<"picture has size ("<<im.Nx()<<","<<im.Ny()<<")"<<std::endl;

        if(size_x>2 && size_y>2)
        {

            color pixel_color=im(size_x/2,size_y/2);
            std::cout<<"pixel ("<<size_x/2<<","<<size_y/2<<") has color=("<<pixel_color<<")"<<std::endl<<std::endl;


            //change color
            std::cout<<"=============== CHANGE COLOR ================"<<std::endl;
            std::cout<<"change pixel ("<<size_x/2<<","<<size_y/2<<") to blue ..."<<std::endl<<std::endl;
            im(size_x/2,size_y/2)=color(255,0,0);


            //save picture
            std::cout<<"=============== SAVE PIC ================"<<std::endl;
            std::string filename_output="pic_output.ppm";
            std::cout<<"save picture to "<<filename_output<<" ..."<<std::endl;
            im.export_ppm(filename_output);
            std::cout<<"save picture to "<<filename_output<<" [OK]"<<std::endl<<std::endl;
        }

    }
    catch(exception_cpe e)
    {
        std::cout<<"**********************************"<<std::endl;
        std::cout<<"**********************************"<<std::endl;
        std::cout<<"Exception found"<<std::endl;
        std::cout<<e.info()<<std::endl;
        std::cout<<"**********************************"<<std::endl;
        std::cout<<"**********************************"<<std::endl;
        exit(1);
    }

    std::cout<<"Exit Main"<<std::endl;
    return 0;
}
